﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="GanttSample.aspx.cs" Inherits="GanttSample.GanttSample" %>

<%--<%@ Register assembly="Syncfusion.EJ" namespace="Syncfusion.JavaScript.Models" tagprefix="ej" %>--%>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Gantt Sample</title>
    <script src="Scripts/Gantt/jquery-1.10.2.min.js"></script>
    <script src="Scripts/Gantt/jquery.globalize.min.js"></script>
    <script src="Scripts/Gantt/jquery.easing.1.3.min.js"></script>
    <script src="Scripts/Gantt/jsrender.min.js"></script>    
    <script src="Scripts/Gantt/ej.web.all.min.js"></script>
    <script src="Scripts/Gantt/globalize.culture.pt-PT.js"></script>
    <link href="Content/Gantt/ej.widgets.core.min.css" rel="stylesheet" />
    <link href="Content/Gantt/ej.theme.min.css" rel="stylesheet" />
</head>
<body>    
    <form id="form1" runat="server" onsubmit="return false" style="overflow: hidden; padding:0; margin: 0;height:100%;width:100%;">        
        
         <ej:Gantt ID="Gantt" runat="server" 
             AllowSelection="true" 
             AllowColumnResize="true"
             TaskIdMapping="Id" 
             TaskNameMapping="Name" 
             StartDateMapping="StartDate" 
             EndDateMapping="EndDate" 
             ProgressMapping="PercentDone"
             ChildMapping="Children" 
             AllowGanttChartEditing="true"
             TreeColumnIndex="1"  ParentTaskIdMapping="ParentId"      
              ScheduleStartDate="01/20/2014"
              ScheduleEndDate="02/28/2014"
               ShowResourceNames="true"
             DateFormat="MM/dd/yyyy"
             EnableResize="true"
             DurationUnit="day" 
             QueryTaskbarInfo="queryTaskbarInfo"  
             Create="create"         ActionComplete="ActionComplete" 
             Load="load" ResourceInfoMapping="ResourceID" ResourceIdMapping="ddvalue" ResourceNameMapping="ddtext">
            <EditSettings AllowEditing="true" EditMode="cellEditing"/>
             <ToolbarSettings ShowToolbar="true" ToolbarItems="add,edit,delete,cancel,update,expandAll,collapseAll,search" />
            <SizeSettings Width="100%" Height="450px" />
        </ej:Gantt>     
        <asp:ScriptManager EnablePageMethods="true" runat="server"></asp:ScriptManager>  
        <script type="text/javascript"> 


            // To update the database through dialog editing or tool bar editing
            function ActionComplete(args) {
                //debugger;
                var ganttObj = $("#Gantt").data("ejGantt");

                if (args.requestType === 'save' && args.addedRecord) {
                    //Newly Added Record is obtained here , which can be updated to database
                    var ganttRecord = args.addedRecord.item;
                    if (args.addedRecord.parentItem)
                        ganttRecord["ParentId"] = args.addedRecord.parentItem.taskId;
                    PageMethods.AddIt(ganttRecord);
                }
                else if (args.requestType === 'delete') {
                    var data = args.data;
                    var ganttRec = data.item;
                    PageMethods.DeleteIt(ganttRec);

                    if (data.hasChildRecords) {
                        deleteChildRecords(data);
                    }
                }
                    // To update the database during Outdent,editing,indent,predecessor update operation
                else if (args.requestType === 'outdent' || args.requestType === 'recordUpdate') {
                    var ganttRec = args.data.item;
                    //debugger;
                    PageMethods.UpdateIt(args.data.item);
                }
            }
            //Delete inner level child records
            function deleteChildRecords(record) {
                var childRecords = record.childRecords,
                    length = childRecords.length,
                    count, currentRecord;
                for (count = 0; count < length; count++) {
                    currentRecord = childRecords[count];
                    PageMethods.DeleteIt(currentRecord.item);
                    if (currentRecord.hasChildRecords) {
                        deleteChildRecords(currentRecord);
                    }
                }
            }

            function load(args) {

                $.ajax({
                    type: "POST",
                    url: "GanttSample.aspx/dropdown",
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: function (value) {
                        var obj = $("#Gantt").data("ejGantt");
                        var columns = obj.getColumns();
                        
                        columns[2].dropdownData = value.d;
                        obj.model.resources = value.d;
                    },
                });
                var obj = $("#Gantt").data("ejGantt");
                var columns = obj.getColumns();
                var columnData = {
                    //field: "DropDown",
                    //headerText: "DropDown",
                    //mappingName: "DropDown",
                    //editType: "dropdownedit",
                    //dropdownData: null,
                    //editParams: { fields: { text: "ddtext", value: "ddtext" } },


                    field: "Resources",
                    headerText: "Resources",
                    mappingName: "Resources",
                    editType: "dropdownedit",
                    dropdownData: null,
                    resourceNameMapping: "ddtext",
                    resourceIdMapping: "ddvalue",
                    resourceInfoMapping:"DropDown",
                    editParams: { fields: { text: "ddtext", value: "ddtext" },showCheckbox:true }

                }
               // columns.splice(2, 0, columnData);
            }
           
   </script>        
    </form>
</body>
</html>
